/* ---------------------------------------------------------------- */
/*																	*/
/* Program  Plotter                                                 */
/*																	*/
/* ---------------------------------------------------------------- */

#include <stdio.h>

#include "fischer.h"

/* ---------------------------------------------------------------- */

int x;
int y;
int x_pos;
int y_pos;
int pc_x;
int pc_y;
int x_direction;
int y_direction;

#define FALSE 0
#define TRUE 1

/* ---------------------------------------------------------------- */

void pen_down( void );
void pen_up( void );
void init( void );
void move_to_xy( int x, int y );
void x_position_drive( void );
void y_position_drive( void );

/* ---------------------------------------------------------------- */

int main()
{
	fischer_install();

	init();

	move_to_xy( 10, 10 );
	pen_down();

	move_to_xy( 15,  10 );
	move_to_xy( 15, 100 );
	move_to_xy(  5, 100 );
	move_to_xy(  5,  10 );

	init();

	return( 0 );
}

/* ---------------------------------------------------------------- */

void pen_down()
{
	motor( 3, CCW );
	while( switch_in( 4 ) );
	motor( 3, OFF );
}

/* ---------------------------------------------------------------- */

void pen_up()
{
	motor( 3, CW );
	while( !switch_in( 4 ) );
	motor( 3, OFF );
}

/* ---------------------------------------------------------------- */

void init()
{
	int i;
	
	motor( 4, CCW );
	pen_up();
	motor( 1, CW );
	while( !switch_in( 3 ) );
	motor( 1, OFF );
	motor( 2, CW );
	while( !switch_in( 2 ) );
	motor( 2, OFF );
	
	for( i = 0 ; i < 10000 ; i++ );
	
	x_pos = 0;
	y_pos = 0;
	pc_x = 1;
	pc_y = 1;
}

/* ---------------------------------------------------------------- */

void move_to_xy( int xv, int yv )
{
	x = xv;
	y = yv;

	do
	{
		if ( x != x_pos )
			x_position_drive();

		if ( y != y_pos )
			y_position_drive();
	} while( x != x_pos || y != y_pos );
}

/* ---------------------------------------------------------------- */

void x_position_drive()
{
	switch( pc_x )
	{
	case 1:	
		if ( x > x_pos )
		{
			x_direction = TRUE;
			motor( 2, CCW );
		}
		else
		{
			x_direction = FALSE;
			motor( 2, CW );
		}

		pc_x++;
		break;
		
	case 2:	
		if ( !switch_in( 5 ) )
			pc_x++;
		break;
		
	case 3:	
		if ( switch_in( 5 ) )
			pc_x++;
		break;

	case 4:	
		if ( x_direction )
			x_pos++;
		else
			x_pos--;
			
		if ( x == x_pos )
		{
			motor( 2, OFF );
			pc_x = 1;
		}
		else
			pc_x = 2;
	}
}

/* ---------------------------------------------------------------- */

void y_position_drive()
{
	switch( pc_y )
	{
	case 1:	
		if ( y > y_pos )
		{
			y_direction = TRUE;
			motor( 1, CCW );
		}
		else
		{
			y_direction = FALSE;
			motor( 1, CW );
		}

		pc_y++;
		break;
		
	case 2:	
		if ( !switch_in( 1 ) )
			pc_y++;
		break;
		
	case 3:	
		if ( switch_in( 1 ) )
			pc_y++;
		break;
		
	case 4:	
		if ( y_direction )
			y_pos++;
		else
			y_pos--;
			
		if ( y == y_pos )
		{
			motor( 1, OFF );
			pc_y = 1;
		}
		else
			pc_y = 2;
	}
}

/* ---------------------------------------------------------------- */
